import wx

class NotebookEX(wx.Notebook):
    def __init__(self, parent, id=-1, pos=wx.DefaultPosition, size=wx.DefaultSize, style=0, name=wx.NotebookNameStr):
        wx.Notebook.__init__(self, parent, id, pos, size, style, name)
        self.pages = []

    def AddPage(self, page, text="", select=False, imageId=-1):
        wx.Notebook.AddPage(self, page, text, select, imageId)
        self.pages.append(page)

    def DeleteAllPages(self):
        wx.Notebook.DeleteAllPages(self)
        del(self.pages[:])

    def DeletePage(self, n):
        wx.Notebook.DeletePage(self,n)
        del(self.pages[n])

    def DeletePageByReference(self, page):
        index = self.pages.index(page)
        wx.Notebook.DeletePage(self, index)
        del(self.pages[index])

    def InsertPage(self, n, page, text="", select=False, imageId=-1):
        wx.Notebook.InsertPage(self, n, page, text, select, imageId)
        self.pages.insert(n,page)

    def RemovePage(self, n):
        wx.Notebook.RemovePage(self,n)
        del(self.pages[n])

    def RemovePageByReference(self, page):
        index = self.pages.index(page)
        wx.Notebook.RemovePage(self, index)
        del(self.pages[index])

    def SetPageImageByReference(self, page, imageId):
        index = self.pages.index(page)
        wx.Notebook.SetPageImage(self, index, imageId)
